<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


function smarty_function_allegro_print_sff( $params, &$smarty ){
    GLOBAL $allegro_sff, $allegro_cats, $allegro_states, $allegro_countries;

    $sff = array();
    if( isset($params['sff_id']) ){
        $sff_id = $params['sff_id'];

        if( empty($allegro_sff[$sff_id]) ){
            return null;
        }

        $sff = $allegro_sff[$sff_id];
    }else if( isset($params['sff']) ){
        $sff = $params['sff'];
    }else{
        return;
    }
    
    $field_id = $sff['id'];

    
    $val = isset($params['value']) ? $params['value'] : '';

    $id = 'aukcja_attribs_'.$sff['id'];
    $name  = 'attribs['.$sff['id'].']';
    
    $label = '<label for="'.$id .'" >' . echtmlspecialchars(trim($sff['title'])) . '</label>: ';
    $input = '';
    
    
    switch( $sff ['type'] ){
        case 1: //if type of field is string
        case 2: //if type of field is integer
        case 3: //if type of field is float
            $input = '<input type="text" class="text" name="'.$name.'" value="'.html_escape($val).'" id="'.$id.'" onblur="allegro_check_input(this, '.$sff ['type'].');" />';
        break;

        case 4: //if type of field is combobox
            $options = allegro_sff_options( $field_id );

            $input .= '<select type="text" class="text" name="'.$name.'" id="'.$id.'" />';
            $input .= html_options($options, $val, false);
            $input .= '</select>'."\n";
        break;

        case 5: //if type of field is radiobutton
            $options = allegro_sff_options( $field_id );

            $i = 0;
            foreach( $options as $k => $v ){
                $idi = $id.'_'.($i);
                $input .= '<input type="radio" name="'.$name.'" id="'.$idi.'" value="' . html_escape($k) . '"> <label for="'.$idi.'">'.echtmlspecialchars($v).'</label>';
                $i++;
            }
        break;

        case 6: //if type of field is checkbox
            $options = allegro_sff_options( $field_id );

            if( !is_array($val) ){
                $val = intval($val);

                if( $val > 0 ){
                    $tmp = array();
                    for( $i = 0, $lp = count($options); $i < $lp; $i++ ){
                        $tmp[$i] = ($val & pow(2, $i))  ? 1  : 0 ;
                    }
                    $val = $tmp;
                }else{
                    $val = array_fill  ( 0, count($options), 0);
                }
            }

            $name  = 'attribs['.$sff['id'].']';
            $i = 0;
            foreach( $options as $k => $v ){
                $idi = $id.'_'.($i);
                $input .= '<input type="checkbox" name="'.$name.'['.$i.']" id="'.$idi.'" value="1" '.( (isset($val[$i]) && $val[$i] == 1) ? 'checked' : '' ).'> <label for="'.$idi.'">'.echtmlspecialchars($v).'</label><br />';
                $i++;
            }
        break;

        case 7: //if type of field is image (base64Binary)
            $input = '<input type="file" class="file" name="'.$name.'" value="" id="'.$id.'" />';
        break;

        case 8: //if type of field is text (textarea)
            $input = '<textarea name="'.$name.'" id="'.$id.'">'.html_escape($val).'</textarea>';
        break;

        case 9: //if type of field is datetime - (second's number since 1.1.1970)
            $input = smarty_function_datetime_input( $name, $val, false, false );
        break;

        case 10: //if type of field is country-id
            $input .= '<select type="text" class="text" name="'. $name .'" id="'.$id.'" />';
            $input .= html_options($allegro_countries, ( ($val > 0) ? $val : $country_code), false);
            $input .= '</select>'."\n";
        break;

        case 11: //if type of field is state-id
            $input .= '<select type="text" class="text" name="'. $name .'" id="'.$id.'" />';
            $input .= html_options($allegro_states, $val, false);
            $input .= '</select>'."\n";
        break;

        case 12: //if type of field is category-id
            $input .= '<input type="hidden" name="'. $name .'" />';

            require_once INCLUDE_DIR .'/allegro.tree.php';
            $tree = allegro_tree::instance();
            $tree -> grupa_id = intval($val);
            $tree -> set_js_name( 'allegro_attrib_' . $field_id );
            $this -> href = 'javascript: allegro_update_cat(%d, \\\'%s\\\', '.$field_id.');';
            $tree -> to_str( $tree_js );
            $input .= '<div id="'.$id.'">'.$tree_js.'</div>'."\n";
        break;

        case 13:
            //* 13 - if type of field is boolean
            $str = '<input type="checkbox" class="checkbox" name="'.$name.'" value="1" id="'.$id.'" />';
        break;
    }

    return '<tr class="attribs"><td width="20%" valign="top">'.$label.'</td><td valign="top">'.$input.'</td></tr>';
}

?>
