<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


function smarty_function_allegro_time_left( $params, &$smarty ){

    $type = $time  = 0;
    if( !isset($params['time']) ){
        return 'Nie przekazano parametru time do funckcji smarty_function_allegro_time_left';
    }
    
    $time = $params['time'];

    if( !isset($params['type']) ){
        if( !is_numeric( $time ) ){
            $type = 1;
        }
    }else{
        $type = $params['type'];
    }
    
    
    if( $type == 1 ){
        list($data, $czas)  = explode(' ', $time );
        list($rok, $miesiac, $dzien)  = explode('-', $data);
        list($godzina, $minuta, $sekunda) = explode(':', $czas );

        $time = mktime (  $godzina, $minuta, $sekunda, $miesiac, $dzien, $rok );

        $liczba_sekund = ($time - $GLOBALS['SCRIPT_START'] );
    }else if( $type == 0 ){
        $liczba_sekund = (intval($time) - $GLOBALS['SCRIPT_START'] );
    }else if( $type == 2 ){
        $liczba_sekund = intval($time);
        $time = $GLOBALS['SCRIPT_START'] + $liczba_sekund;
    }else{
        return 'Nie rozpoznany parametr type';
    }
    
    $str = '';
    
    if( $liczba_sekund < 0 ){
        $str = '<font color="#02910D">Zakoczona</font>';
        
        $smarty->assign('is_ended', 1);
    }else{
        $smarty->assign('is_ended', 0);
        
        $dni = floor($liczba_sekund / (24 * 60 * 60) );
        
        if( $dni > 0 ){
            if( $dni == 1 ){
                $str .=  '1 dzie ';
            }else{
                $str .=  $dni . ' dni ';
            }

            $liczba_sekund -= ($dni * 24 * 60 * 60);
        }

        $godz = floor($liczba_sekund / 3600);
        
        if( $godz > 0 ){
    /*
            if( $godz == 1 ){
                $str =   '1 godzina ';
            }else if( $godz < 5 ){
                $str =   $godz . ' godziny ';
            }else{
                $str =   $godz . ' godzin ';
            }

    */
            $str .=   $godz . ' godz. ';

            $liczba_sekund -= ($godz * 60 * 60);
        }

        $min = floor($liczba_sekund / 60);

        if( ($min > 0) ){
            if( $min == 1 ){
                $str .=   ' 1 minuta ';
            }else if( $min < 5 || ( ($min > 21) && (($m = floor($min % 10)) > 1) && ($m < 5)  ) ){
                $str .=   $min . ' minuty ';
            }else{
                $str .=   $min . ' minut ';
            }

            $liczba_sekund -= ($min * 60);
        }else if( empty($str) ){
            $str = 'mniej ni minuta';
        }
/*
        if( $liczba_sekund > 0 ) {
            if( $liczba_sekund == 1 ){
                $str =   '1 sekunda';
            }else if( $liczba_sekund < 5 ){
                $str =   $liczba_sekund . ' sekundy ';
            }else{
                $str =   $liczba_sekund . ' sekund ';
            }
        }
*/

        $str = ( ($dni == 0 && $godz < 6 ) ? '<font color="#ff0000">' . $str .'</font>' : $str );
    }

    //nie 26 kwi 2009 13:22:44 CEST
    $time_format = '%c';
    $time_format = '%a %d %b %Y %H:%M:%S';
    
    return '<b>'.$str.'</b><br /><span class="small">('.strftime($time_format, $time ).')</span>';
}

?>

