<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


function smarty_function_categories_print($params, &$smarty){
    global $dbh1;

    if ( !is_resource($dbh1) ) {
        return '<div class="cats">&nbsp;</div>';
    }
    
    $ext  = $smarty->get_template_vars('ext');
    $tree = $smarty->get_template_vars('drzewko');
    $logged = $smarty->get_template_vars('logged');

    if( empty($tree) ){
        if( !class_exists('drzewko') ){
            require_once( INCLUDE_DIR . '/drzewko.class.php' );
        }

        $root_id = 0;
        if ( defined('GRUPYT_EXT') && GRUPYT_EXT == 1 ){
            $ext = 1;
        }

        if( defined('GM_GRUPAT_EXT_ID') && GM_GRUPAT_EXT_ID > 0 ){
            $ext = 1;
            $root_id = GM_GRUPAT_EXT_ID;
        }

        $gid = $smarty->get_template_vars('gid');
        $tree = new drzewko('towary', $gid, $ext, true, false, $root_id );
    }

    echo '<div class="cats">';
    print_tree( $tree, '', $logged );
    echo '</div>';
}

function print_tree( $tree, $ext = '', $logged = false ){
    $stos = array();

    $gid = $tree->grupa_id;
    $cats = $tree->items[0]->items;
    
    $cat = $cats[0];
    $cat_num = 0;
    $cats_count = count($cats);
    $cat_level  = 1;
    
    
    $inne = false;
    
    while( !empty($cat) ){
        $cat_num++;        
        
        if ( $cat_level == 1 ) {
            $nazwa = strtolower(trim($cat->nazwa));
            echo '<div class="bar '.$nazwa.'"><h3><a href="'.URL_PATH.'/'.name2url($cat->nazwa). '-g'.$ext.'-'. $cat->id.'.html">'.$cat->nazwa.'</a></h3></div>';
        } else {
            echo '<li class="'.( empty( $cat->items ) ? '' : (  $cat->opened  ? 'opened' : 'closed' ) ).(($cat->selected || ($cat->id == $gid))? ' selected' : '' ).'"><a href="'.URL_PATH.'/'.name2url($cat->nazwa). '-c'.$ext.'-'. $cat->id.'.html"  >' . $cat->nazwa . '</a></li>';
        }
        
        
        if ( !empty( $cat->items ) ) {
            $cat_level++;
            echo '<div class="items level'.$cat_level.'"><ul>';

            $stos[] = array('cats' => $cats, 'num'  => $cat_num, 'count'  => $cats_count );

            $cats = $cat->items;
            $cat  = $cat->items[0];
            $cat_num = 0;
            $cats_count = count($cats);

        } else if ( $cat_num < $cats_count ) {
            $cat  = $cats[$cat_num];
        } else {
            $cat = null;
            
            while( empty($cat) && !empty($stos) ){
                $cat_level--;
                $el = array_pop( $stos );
                echo '</ul></div>';

                $cats = $el['cats'];
                $cat_num = $el['num'];
                $cats_count = $el['count'];
                $cat = $cats[$cat_num];
            }
        }
    }
}
