<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */

require_once( LIB_DIR . '/fpdf/fpdf.php');
require_once( CLASS_DIR . '/ec_pdf.php');

function smarty_function_fs2pdf($params, &$smarty){
    $doc = $smarty->get_template_vars('faktura');

    $pdf = new EC_PDF();

    $pdf->SetLeftMargin(20); $pdf->SetRightMargin(20);

    $font_name = 'myArial';

    $pdf->AddFont($font_name, '', 'arial.php');
    $pdf->AddFont($font_name, 'B', 'arialbd.php');
    $pdf->AddFont($font_name, 'I', 'ariali.php');

    $pdf->SetFont($font_name, '',12);
    //aby zrobi w stopce zamiane z {nb} na akowita liczbe stron w PDF-ie
    $pdf->AliasNbPages();
    $pdf->AddPage();

/******************************************************************************/

    if ( $GLOBALS['WYDRUKI_LOGO_FIRMY']&& FIRMA_LOGO_ID > 0){
        $logo_file = ROOT_PATH.'/'.IMAGES_DIR_NAME .'/' . FIRMA_LOGO_FNAME;
    }else{
        $logo_file = $GLOBALS['SZABLON_PATH'] . '/images/logo.jpg';
    }

    if( file_exists($logo_file) )
    $pdf->Image( $logo_file, $pdf->getX(), $pdf->getY(), 30 );

    $pdf->SetFont($font_name, '', 8);
    $pdf->Cell(0, 4, FIRMA_PLACE . ', ' . $doc->DATA_WYSTAWIENIA, 0, 1, 'R');
    $pdf->Cell(0, 4, 'Data sprzeday: ' . $doc->DATA_SPRZEDAZY, 0, 1, 'R');
    $pdf->Ln(5);

    $pdf->SetFont($font_name, '', 8);
    $pdf->Cell(0, 4, 'FAKTURA VAT', 0, 1, 'C');

    $pdf->SetFont($font_name, 'B', 16);
    $pdf->Cell(0, 10, $doc->NUMER, 0, 1, 'C');

    $pdf->SetFont($font_name, 'B', 8 );
    $pdf->Cell(0, 2, 'KOPIA 1', 0, 1, 'C');

    $pdf->Ln(10);

/**************************************************************************************************/
    $odstep = 2;
    $polowa = round(($pdf->w - $pdf->lMargin - $pdf->rMargin - $odstep) / 2);

    $pdf->SetFillColor(212);

    $pdf->SetFont($font_name, 'B', 8 );
    $pdf->Cell( $polowa, 5, 'SPRZEDAWCA', 0, 0, 'L', true);
    $pdf->Cell( $odstep, 5, '', 0, 0, 'L', false);
    $pdf->Cell($polowa, 5, 'NABYWCA', 0, 1, 'L', true);

    $pdf->SetFont($font_name, '', 8 );
    $pdf->Cell( $polowa, 4, FIRMA_SHORT_NAME, 0, 0, 'L', false);
    $pdf->Cell( $odstep, 4, '', 0, 0, 'L', false);
    $pdf->Cell($polowa, 4, $doc->NAZWA_SKROCONA_PLATNIKA, 0, 1, 'L', false);


    $pdf->Cell( $polowa, 4, FIRMA_ADDRESS, 0, 0, 'L', false);
    $pdf->Cell( $odstep, 4, '', 0, 0, 'L', false);
    $pdf->Cell($polowa, 4, 'Ul. ' . $doc->ULICA_PLATNIKA. ' '. $doc->NRDOMU_PLATNIKA.'/'.$doc->NRLOKALU_PLATNIKA, 0, 1, 'L', false);

    $pdf->Cell( $polowa, 4, FIRMA_ZIPCODE . ' ' . FIRMA_PLACE, 0, 0, 'L', false);
    $pdf->Cell( $odstep, 4, '', 0, 0, 'L', false);
    $pdf->Cell($polowa, 4, $doc->KOD_PLATNIKA. ' '. $doc->MIEJSCOWOSC_PLATNIKA, 0, 1, 'L', false);

    $pdf->Cell( $polowa, 4, 'NIP: '.FIRMA_NIP, 0, 0, 'L', false);
    $pdf->Cell( $odstep, 4, '', 0, 0, 'L', false);
    $pdf->Cell($polowa, 4, 'NIP: '.$doc->NIP_PLATNIKA, 0, 1, 'L', false);

/**************************************************************************************************/

    $pdf->SetFont($font_name, 'B', 8 );
    $pdf->Cell( $polowa, 5, 'RACHUNEK BANKOWY', 0, 0, 'L', true);
    $pdf->Cell( $odstep, 5, '', 0, 0, 'L', false);
    $pdf->Cell($polowa, 5, 'ODBIORCA', 0, 1, 'L', true);

    $pdf->SetFont($font_name, '', 8 );
    $pdf->Cell( $polowa, 4, $doc->BANK_NAZWA, 0, 0, 'L', false);
    $pdf->Cell( $odstep, 4, '', 0, 0, 'L', false);
    $pdf->Cell($polowa, 4, $doc->NAZWA_PELNA_ODBIORCY, 0, 1, 'L', false);


    $pdf->Cell( $polowa, 4, $doc->NUMER_KONTA, 0, 0, 'L', false);
    $pdf->Cell( $odstep, 4, '', 0, 0, 'L', false);
    $pdf->Cell($polowa, 4, 'Ul. ' . $doc->ULICA_ODBIORCY. ' '. $doc->NRDOMU_ODBIORCY . '/' . $doc->NRLOKALU_ODBIORCY, 0, 1, 'L', false);

    $pdf->Cell( $polowa, 4, '', 0, 0, 'L', false);
    $pdf->Cell( $odstep, 4, '', 0, 0, 'L', false);
    $pdf->Cell($polowa, 4, $doc->KOD_ODBIORCY. ' '. $doc->MIEJSCOWOSC_ODBIORCY, 0, 1, 'L', false);

    $pdf->Cell( $polowa, 4, '', 0, 0, 'L', false);
    $pdf->Cell( $odstep, 4, '', 0, 0, 'L', false);
    $pdf->Cell($polowa, 4, 'NIP: '.$doc->NIP_ODBIORCY, 0, 1, 'L', false);

/**************************************************************************************************/
    $pdf->SetFont($font_name, 'B', 8 );
    $pdf->Cell( $polowa, 5, 'SPOSB ZAPATY', 0, 0, 'L', true);
    $pdf->Cell( $odstep, 5, '', 0, 0, 'L', false);
    $pdf->Cell($polowa, 5, 'SPOSB WYLICZANIA WARTOCI DOKUMENTU', 0, 1, 'L', true);

    $pdf->SetFont($font_name, '', 8 );
    $pdf->Cell( $polowa, 4, $doc->NAZWA_SPOSOBU_PLATNOSCI, 0, 0, 'L', false);
    $pdf->Cell( $odstep, 4, '', 0, 0, 'L', false);
    $pdf->Cell($polowa, 4, $doc->SPOSOB_LICZENIA_NAZWA, 0, 1, 'L', false);

    $pdf->SetFont($font_name, 'B', 8 );
    $pdf->Cell( $polowa, 5, 'DATA PATNOCI', 0, 1, 'L', true);
    $pdf->SetFont($font_name, '', 8 );
    $pdf->Cell($polowa, 4, $doc->DATA_PLATNOSCI, 0, 1, 'L', false);

/**************************************************************************************************/
    $pdf->SetFont($font_name, 'B', 8 );
    $pdf->Cell( 0, 5, 'MAGAZYN', 0, 1, 'L', true);
    $pdf->SetFont($font_name, '', 8 );
    $pdf->Cell( 0, 4, $doc->MAGAZYN_NAZWA, 0, 1, 'L', false);
    
/**************************************************************************************************/
if( !empty($doc->SYGNATURA) ){
    $pdf->SetFont($font_name, 'B', 8 );
    $pdf->Cell( 0, 5, 'SYGNATURA', 0, 1, 'L', true);
    $pdf->SetFont($font_name, '', 8 );
    $pdf->Cell( 0, 4, $doc->SYGNATURA, 0, 1, 'L', false);
}

if( !empty($doc->wz) ){
    $pdf->SetFont($font_name, 'B', 8 );
    $pdf->Cell( 0, 5, 'DOKUMENTY WYDANIA ZEWNTRZENEGO', 0, 1, 'L', true);
    $pdf->SetFont($font_name, '', 8 );

    for( $i = 0, $lp = count($doc->wz); $i < $lp; $i++ ){
/*
          <tr class="{cycle values="browserodd, browsereven"}">
            <td class=fvdane>{$faktura->wz[w].KOD}&nbsp;</td>
            <td class=fvdane>{$faktura->wz[w].NUMER} z dnia:</td>
            <td class=fvdane>{$faktura->wz[w].DATA_WYSTAWIENIA}&nbsp;</td>
          </tr>
*/
    }
}

    $pdf->Ln(10);

/**************************************************************************************************/
    $pdf->SetFont($font_name, 'B', 6 );

    $lp_width  = 6;
    $th_height = 10;

    $pdf->Cell( $lp_width, $th_height, 'LP', 1, 0, 'C', true);
    $nazwa_width = 50;
    $pdf->Cell( $nazwa_width, $th_height, 'NAZWA TOWARU LUB USUGI', 1, 0, 'C', true);

    $pkwiu_width = 10;
    $pdf->Cell( $pkwiu_width, $th_height, 'PKWIU', 1, 0, 'C', true);

    $jm_width = 8;
    $pdf->Cell( $jm_width, $th_height, 'J.M.', 1, 0, 'C', true);

    $ilosc_width = 10;
    $pdf->Cell( $ilosc_width, $th_height, 'ILO', 1, 0, 'C', true);

    $cena_width = 15;
    $x = $pdf->GetX(); $y = $pdf->getY();
    $pdf->Cell( $cena_width, $th_height, "", 1, 0, 'C', true);
    $pdf->SetXY( $x, $y + 1.8);
    $pdf->MultiCell( $cena_width, 2, "CENA JEDN.\nNETTO BEZ\n R/N", 0, 'C', false);
    $pdf->SetXY( $x + $cena_width, $y );

    $rabat_width = 12;
    $x = $pdf->GetX(); $y = $pdf->getY();
    $pdf->Cell( $rabat_width, $th_height, "", 1, 0, 'C', true);
    $pdf->SetXY( $x, $y + 3);
    $pdf->MultiCell( $rabat_width, 2, "RABAT\n[%]", 0, 'C', false);
    $pdf->SetXY( $x + $rabat_width, $y );

    $cena_rabat_width = 15;
    $x = $pdf->GetX(); $y = $pdf->getY();
    $pdf->Cell( $cena_rabat_width, $th_height, "", 1, 0, 'C', true);
    $pdf->SetXY( $x, $y + 3);
    $pdf->MultiCell( $cena_rabat_width, 2, "CENA JEDN.\n NETTO", 0, 'C', false);
    $pdf->SetXY( $x + $cena_rabat_width, $y );

    $wartosc_width = 15;
    $x = $pdf->GetX(); $y = $pdf->getY();
    $pdf->Cell( $wartosc_width, $th_height, "", 1, 0, 'C', true);
    $pdf->SetXY( $x, $y + 3);
    $pdf->MultiCell( $wartosc_width, 2, "WARTO\nNETTO", 0, 'C', false);
    $pdf->SetXY( $x + $wartosc_width, $y );

    $podatek_width = 15;
    $x = $pdf->GetX(); $y = $pdf->getY();
    $pdf->Cell( $podatek_width, $th_height / 2, "PODATEK", 1, 2, 'C', true);
    $podatek_procent_width = $podatek_width * 0.3;
    $pdf->Cell( $podatek_procent_width, $th_height / 2, "%", 1, 0, 'C', true);
    $podatek_kwota_width = $podatek_width * 0.7;
    $pdf->Cell( $podatek_kwota_width, $th_height / 2, "KWOTA", 1, 0, 'C', true);
    $pdf->SetXY( $x + $podatek_width, $y );

    $wart_pod_width = 15;
    $x = $pdf->GetX(); $y = $pdf->getY();
    $pdf->Cell( $wart_pod_width, $th_height, "", 1, 0, 'C', true);
    $pdf->SetXY( $x, $y + 3);
    $pdf->MultiCell( $wart_pod_width, 2, "WARTO Z\nPODATKIEM", 0, 'C', false);

    $pdf->SetXY( $x, $y + $th_height);


    $pdf->SetFont($font_name, '', 6 );
/**************************************************************************************************/

    for( $i = 0, $lp = count($doc->pozycje); $i < $lp; $i++ ){
        $pozycja = $doc->pozycje[$i];

        $td_fill = false; $td_height = 12;

        $y1 = $pdf->getY();
        $pdf->Cell( 0, $td_height, '', 0, 1, 'C', false );
        $y2 = $pdf->getY();
        if( $y2 > $y1 ){
            $pdf->setY($y1);
        }

        //pobieram pozycje Y
        $y = $pdf->getY();  $x = $pdf->getX();

        $pdf->setY( $y + 3 );
        $pdf->MultiCell( $lp_width, 2, ($i+1).'. ', 0, 'R', false );
        $pdf->setXY( $x += $lp_width, $y + 3 );
        $pdf->MultiCell( $nazwa_width, 2, $pozycja['NAZWA_ORYGINALNA'], 0, 'L', false );
        $pdf->setXY( $x += $nazwa_width, $y + 3 );
        $pdf->MultiCell( $pkwiu_width, 2, $pozycja['PKWIU'], 0, 'C', false );
        $pdf->setXY( $x += $pkwiu_width, $y + 3 );
        $pdf->MultiCell( $jm_width, 2, $pozycja['JEDNOSTKA_SKROT'], 0, 'R', false );
        $pdf->setXY( $x += $jm_width, $y + 3 );
        $pdf->MultiCell( $ilosc_width, 2, $pozycja['ILOSC'], 0, 'R', false );
        $pdf->setXY( $x += $ilosc_width, $y + 3 );
        $pdf->MultiCell( $cena_width, 2, format_waluty($pozycja['CENA_SP_PLN_NETTO']), 0, 'R', false );
        $pdf->setXY( $x += $cena_width, $y + 3 );
        $pdf->MultiCell( $rabat_width, 2, $pozycja['RABAT'], 0, 'C', false );
        $pdf->setXY( $x += $rabat_width, $y + 3 );
        $pdf->MultiCell( $cena_rabat_width, 2, format_waluty($pozycja['CENA_SP_PLN_NETTO']), 0, 'R', false );
        $pdf->setXY( $x += $cena_rabat_width, $y + 3 );
        $pdf->MultiCell( $wartosc_width, 2, format_waluty($pozycja['PLN_WARTOSC_NETTO']), 0, 'R', false );
        $pdf->setXY( $x += $wartosc_width, $y + 3 );
        $pdf->MultiCell( $podatek_procent_width, 2, $pozycja['STAWKA'], 0, 'C', false );
        $pdf->setXY( $x += $podatek_procent_width, $y + 3 );
        $pdf->MultiCell( $podatek_kwota_width, 2, format_waluty($pozycja['PLN_KWOTA_VAT']), 0, 'R', false );
        $pdf->setXY( $x += $podatek_kwota_width, $y + 3 );
        $pdf->MultiCell( $wart_pod_width, 2, format_waluty($pozycja['PLN_WARTOSC_BRUTTO']), 0, 'R', false );

        $pdf->setY( $y );
        $pdf->Cell( $lp_width, $td_height, '', 1, 0, 'C', $td_fill );
        $pdf->Cell( $nazwa_width, $td_height, '', 1, 0, 'C', $td_fill );
        $pdf->Cell( $pkwiu_width, $td_height, '', 1, 0, 'C', $td_fill);
        $pdf->Cell( $jm_width, $td_height, '', 1, 0, 'C', $td_fill);
        $pdf->Cell( $ilosc_width, $td_height, '', 1, 0, 'C', $td_fill);
        $pdf->Cell( $cena_width, $td_height, '', 1, 0, 'C', $td_fill);
        $pdf->Cell( $rabat_width, $td_height, '', 1, 0, 'C', $td_fill);
        $pdf->Cell( $cena_rabat_width, $td_height, '', 1, 0, 'C', $td_fill);
        $pdf->Cell( $wartosc_width, $td_height, '', 1, 0, 'C', $td_fill);
        $pdf->Cell( $podatek_procent_width, $td_height, '', 1, 0, 'C', $td_fill);
        $pdf->Cell( $podatek_kwota_width, $td_height, '', 1, 0, 'C', $td_fill);
        $pdf->Cell( $wart_pod_width, $td_height, '', 1, 0, 'C', $td_fill);

        $pdf->Ln();
    }

/**************************************************************************************************/
    for( $i = 0, $lp = count($doc->razem); $i < $lp; $i++ ){
        $wiersz = $doc->razem[$i];

        $td_fill = false; $td_height = 12;

        $y1 = $pdf->getY();
        $pdf->Cell( 0, $td_height, '', 0, 1, 'C', false );
        $y2 = $pdf->getY();
        if( $y2 > $y1 ){
            $pdf->setY($y1);
        }

        //pobieram pozycje Y
        $y = $pdf->getY();
        $w = $lp_width + $nazwa_width  + $pkwiu_width + $jm_width + $ilosc_width + $cena_width + $rabat_width + $cena_rabat_width;
        $x = $pdf->getX() + $w;

        $pdf->setXY( $x , $y + 3 );
        $pdf->MultiCell( $wartosc_width, 2, format_waluty($wiersz['PLN_WARTOSC_NETTO']), 0, 'R', false );
        $pdf->setXY( $x += $wartosc_width, $y + 3 );
        $pdf->MultiCell( $podatek_procent_width, 2, $wiersz['STAWKA'], 0, 'C', false );
        $pdf->setXY( $x += $podatek_procent_width, $y + 3 );
        $pdf->MultiCell( $podatek_kwota_width, 2, format_waluty($wiersz['PLN_KWOTA_VAT']), 0, 'R', false );
        $pdf->setXY( $x += $podatek_kwota_width, $y + 3 );
        $pdf->MultiCell( $wart_pod_width, 2, format_waluty($wiersz['PLN_WARTOSC_BRUTTO']), 0, 'R', false );

        $pdf->setY( $y );
        $pdf->Cell( $w, $td_height, '', 0, 0, 'C', $td_fill );
        $pdf->Cell( $wartosc_width, $td_height, '', 1, 0, 'C', $td_fill);
        $pdf->Cell( $podatek_procent_width, $td_height, '', 1, 0, 'C', $td_fill);
        $pdf->Cell( $podatek_kwota_width, $td_height, '', 1, 0, 'C', $td_fill);
        $pdf->Cell( $wart_pod_width, $td_height, '', 1, 0, 'C', $td_fill);

        $pdf->Ln();
    }

/**************************************************************************************************/

    $y1 = $pdf->getY();
    $pdf->Cell( 0, $td_height, '', 0, 1, 'C', false );
    $y2 = $pdf->getY();
    if( $y2 > $y1 ){
        $pdf->setY($y1);
    }

    //pobieram pozycje Y
    $y = $pdf->getY();
    $w = $lp_width + $nazwa_width  + $pkwiu_width + $jm_width + $ilosc_width + $cena_width;
    $x = $pdf->getX() + $w;

    $pdf->setXY( $x, $y );
    $pdf->Cell( $rabat_width + $cena_rabat_width, $td_height, 'RAZEM: ', 1, 0, 'R', true );
    $x += ($rabat_width + $cena_rabat_width);

    $pdf->setXY( $x, $y );
    $pdf->Cell( $wartosc_width, $td_height, '', 1, 0, 'C', true);
    $pdf->setXY( $x, $y + 3 );
    $pdf->MultiCell( $wartosc_width, 2, format_waluty($doc->PLN_WARTOSC_NETTO), 0, 'R', false );

    $pdf->setXY( $x += $wartosc_width, $y );
    $pdf->Cell( $podatek_procent_width, $td_height, '', 1, 0, 'C', true);
    $pdf->setXY( $x, $y + 3 );
    $pdf->MultiCell( $podatek_procent_width, 2, 'X', 0, 'C', false );

    $pdf->setXY( $x += $podatek_procent_width, $y );
    $pdf->Cell( $podatek_kwota_width, $td_height, '', 1, 0, 'C', true);
    $pdf->setXY( $x, $y + 3 );
    $pdf->MultiCell( $podatek_kwota_width, 2, format_waluty($doc->PLN_KWOTA_VAT), 0, 'R', false );

    $pdf->setXY( $x += $podatek_kwota_width, $y );
    $pdf->Cell( $wart_pod_width, $td_height, '', 1, 0, 'C', true);
    $pdf->setXY( $x, $y + 3 );
    $pdf->MultiCell( $wart_pod_width, 2, format_waluty($doc->PLN_WARTOSC_BRUTTO), 0, 'R', false );

    $pdf->Ln();

/**************************************************************************************************/

    $pdf->Ln(20);

    $pdf->SetFont($font_name, 'B', 8 );
    $pdf->Cell( 24, 8, 'DO ZAPATY: ', 0, 0, 'L', false);
    $pdf->SetFont( $font_name, 'B', 16 );
    $pdf->Cell( 0, 8, format_waluty($doc->PLN_WARTOSC_BRUTTO), 0, 1, 'L', false);

    $pdf->SetFont($font_name, 'B', 8 );
    $pdf->Cell( 24, 5, 'SOWNIE: ', 0, 0, 'L', false);
    $pdf->SetFont($font_name, '', 8 );
    $pdf->Cell( 0, 5, $doc->KWOTA_SLOWNIE, 0, 1, 'L', false);

    $pdf->Ln(30);

    $pdf->SetFont($font_name, '', 8 );
    $pdf->Cell( $polowa, 5, '...................................................................................', 0, 0, 'C', false);
    $pdf->Cell( $polowa, 5, '...................................................................................', 0, 1, 'C', false);
    
    $pdf->SetFont($font_name, 'I', 5 );
    $x = $pdf->getX() ;
    $y = $pdf->getY() - 1;
    $pdf->setXY( $x, $y );
    $pdf->MultiCell( $polowa, 2, "podpis osoby upowanionej do \n wystawienia faktury", 0, 'C');
    $pdf->setXY( $x+ $polowa, $y );
    $pdf->MultiCell( $polowa, 2, "podpis osoby upowanionej do \n odbioru faktury", 0, 'C');
    
if( !empty($doc->UWAGI_STR) ){
    $pdf->Ln(40);
    
    $pdf->SetFont( $font_name, 'B', 8 );
    $pdf->Cell( 0, 5, 'UWAGI', 0, 1, 'L', true);

    $pdf->SetFont( $font_name, '', 8 );
    $pdf->SetY( $pdf->GetY()+5 );
    $pdf->MultiCell( 0, 3, $doc->UWAGI_STR, 0, 'L', false );
}
/**************************************************************************************************/

    $pdf->Output();
}


?>
