<?php
/**
 * Wymagany przekazany parametr url do zakodowania  w serwisie tinyurl.com
 *
 * @param array $params
 * @param SmartyRaks $smarty
 * @return string
 */
function smarty_function_tinyurl( $params, &$smarty ){

    $tinyurl = '';
    if( !empty($params['url']) ){
        //dodaje http:// jesli adres sie nei zaczyna
        $url = $params['url'];
        if ( strtolower(substr($url, 0, 7)) != 'http://' ) {
            $url = $smarty->get_template_vars('HTTP_HOST') . (substr($url, 0, 1) == '/' ? '' : '/') . $url;
        }

        $ch = curl_init();
        $timeout = 5;
        curl_setopt($ch, CURLOPT_URL,'http://tinyurl.com/api-create.php?url=' . urlencode($url) );
        curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT,$timeout);
        $tinyurl = curl_exec($ch);
        curl_close($ch);

        if( !empty($params['assign']) ){
            if( $params['assign'] === true ) {
                $smarty->assign('tinyurl', $tinyurl);
            } else if ( is_string($params['assign']) && preg_mathc('/^[a-zA-Z]([a-zA-Z0-9\_]+)$/', $params['assign']) ) {
                $smarty->assign($params['assign'], $tinyurl) ;
            }
        }
    }

    return $tinyurl;
}



