// JavaScript Document
function Panel(){
    this.length = 0;
    this.okienka = [];
    this.top_index = 0;

    this.add = panel_add;
    this.del = panel_del;
    this.is_visible = panel_is_visible;
    this.is_on = panel_is_on;
    this.set_visible = panel_set_visible;
    this.set_z_index = panel_set_z_index;
    this.bring_up = panel_bring_up;
    this.clear = panel_clear;
}

function panel_add( index, obj ){

    var i = 0;
    for( i = 0; i < this.okienka.length; i++ ){
        if( this.okienka[i] ){
            this.okienka[i].visible = false;
        }
    }
    
    this.length++;

    this.okienka[index] = {
      'obj' : obj,
      'level' : this.length,
      'id' : obj.id,
      'visible' : true,
      'closed' : false
    }

    this.top_index = index;

    this.set_z_index();
}

function panel_del( index ){
    if( !this.okienka[index] ) return;
    
    this.okienka[index].closed = true;
    this.okienka[index].visible = false;
    var old_level = this.okienka[index].level;
    this.okienka[index].level = 0;

    this.length--;
    
    var i = 0;
    if( this.top_index == index ){
        for( i = 0; i < this.okienka.length; i++ ){
            if( this.okienka[i] && this.okienka[i].level == this.length ){
                this.top_index = i;
                break;
            }
        }
    }else{
        for( i = 0; i < this.okienka.length; i++ ){
            if( this.okienka[i] && this.okienka[i].level > old_level )
                this.okienka[i].level--;
        }
    }

    this.set_z_index();
}


function panel_is_visible( index ){

    if ( this.okienka[index] ){
      return this.okienka[index].visible
    }

    return false;
}

function panel_is_on( index ){

    if ( this.okienka[index] ){
      return !this.okienka[index].closed;
    }

    return false;
}



function panel_set_visible( index ){

    var i = 0;
    for( i = 0; i < this.okienka.length; i++ ){
        if( this.okienka[i] && this.okienka[i].level > this.okienka[index].level  ){
            this.okienka[i].level--;
        }
    }

    this.okienka[this.top_index].visible = false;


    this.okienka[index].visible = true;
    this.okienka[index].closed = false;
    this.okienka[index].level = this.length;
    this.top_index = index;

    this.set_z_index();

    return false;
}


function  panel_set_z_index(){
/*
    max_zindex = parseInt( okienka[okienka.length-1].style.zIndex );
    if( max_zindex <= 0 ){
        max_zindex = 120 + okienka.length;
    }
*/

    var a = null;
    for( var i = 0; i < this.okienka.length; i++ ){
        if( this.okienka[i] && !this.okienka[i].closed ){
            a = this.okienka[i];
            a.obj.style.zIndex = 110 + a.level;
        }
    }

}


function panel_bring_up( index ){

    if( !this.okienka[index] ){
        return;
    }

    if( this.okienka[index].visible || this.okienka[index].closed ){
        return;
    }

    this.set_visible(index, true);

}


function panel_clear(){
    
    this.okienka = [];
    
    this.length = 0;
    
    this.top_index = 0;
}
