function tree (a_items, a_template) {

//*** stuktura drzewa *****/
/* oparte na listach UL  */

    this.a_tpl      = a_template;
    this.a_config   = a_items;
    this.o_root     = this;
    this.a_index    = [];
    this.o_selected = null;
    this.n_depth    = -1;

    this.b_selected = null;
    this.b_pozycja = 0;

    this.select = function (n_id) { var o_item = this.a_index[n_id]; o_item.select(!o_item.b_selected, true); };

    this.a_children = [];
    for (var i = 0; i < a_items.length; i++)   new tree_item(this, i);

    this.b_children = this.a_children.length > 0;

    this.n_id = trees.length;
    trees[this.n_id] = this;

/****  wypisanie drzewa  ******/

    document.write('<ul class="drzewo">');
    for (var i = 0; i < this.a_children.length; i++) document.write(this.a_children[i].init());
    document.write('</ul>');

/******************************/
}

function tree_item (o_parent, n_order) {

    this.n_depth  = o_parent.n_depth + 1;
    this.a_config = o_parent.a_config[n_order + (this.n_depth ? 4 : 0)];
    if (!this.a_config) return;

    this.o_root    = o_parent.o_root;
    this.o_parent  = o_parent;
    this.n_order   = n_order;
    this.b_selected = Boolean(this.a_config[2]);
    this.b_pozycja = this.a_config[3];

    this.n_id = this.o_root.a_index.length;
    this.o_root.a_index[this.n_id] = this;
    o_parent.a_children[n_order] = this;

    this.a_children = [];
    this.b_children = false;


    if( this.a_config.length - 3 > 0 ) {
        this.b_children = true;

        for (var i = 0; i < this.a_config.length - 3; i++)
            new tree_item(this, i);
        this.b_children = this.a_children.length > 0;
    }

    this.init     = item_init;
}


// na liscie UL
function item_init () {
        var a_offset = [],
        o_current_item = this.o_parent;

    var html = new String();

   html = '<li class="tree_item" name="' + this.a_config[0] + '" pozycja="'+this.b_pozycja+'"  style="position: relative;"><div class="separator"></div>' + (this.n_depth ? a_offset.join('') +

        (this.b_children ? '<span class="plus"></span>' : '<span ></span>') : '')
        + '<label class="t' + this.o_root.n_id + 'i" for="i_chx' + this.o_root.n_id + '_' + this.n_id + '">'
        + '<input class="chbox" type="checkbox" name="" value="false" ' + (this.b_selected?"checked":"") + ' id="i_chx' + this.o_root.n_id + '_' + this.n_id + '">'
        + this.a_config[0]
        + '<input type="hidden" class="id" name="' + this.o_root.a_tpl['checkbox_name'] + '['+this.a_config[1]+'][id]" value="'+this.a_config[1]+'" />'
        + '<input type="hidden" class="parent_id" name="' + this.o_root.a_tpl['checkbox_name'] + '['+this.a_config[1]+'][parent_id]" value="'+this.o_parent.a_config[1]+'" />'
        + '<input type="hidden" class="pozycja" name="' + this.o_root.a_tpl['checkbox_name'] + '['+this.a_config[1]+'][pozycja]" value="'+ this.b_pozycja +'" />'
        + '<input type="hidden" class="wyswietl" name="' + this.o_root.a_tpl['checkbox_name'] + '['+this.a_config[1]+'][wyswietl]" value="'+ ((this.b_selected)? 1:0) +'" />'
        + '</label>'
        ;

    if( this.b_children ){
        html += '<ul id="i_div' + this.o_root.n_id + '_' + this.n_id + '" style="display:none">';
           for(var k=0; k < this.a_children.length; k++) html += this.a_children[k].init();
        html += '</ul>';
    }

    html += '</li>';
    return html;
}


var trees = [];
var TREE_DRAGABLE = true;


/******** Zachowanie drzewa po wyswietleniu: przesowanie elementow, rozwijanie ... ********************/


$(document).ready(function(){
    rozwin = function( plus ){
         view(plus,plus.parent().children('ul'));
    }

    //pierwszy element hack
    $('.drzewo>li>div').after('<span class="plus"></span>');
    rozwin($('.drzewo>li>span'));

    $(".plus").live('click',function(){
        rozwin ($(this));
    });

    $(" li label").bind('mouseenter',function(){
        $('li').removeClass('on');
        $(this).parent('li').addClass('on');
    });

    $(".drzewo li").bind('mouseout',function(){
        $(this).removeClass('on');
    });

if ( TREE_DRAGABLE ) {
$("li.tree_item label").droppable({
		tolerance		: "pointer",
		hoverClass		: "hover",
		drop			: function(event, ui){
			var dropped = ui.draggable;
			dropped.css({top: 0, left: 0});
			var me = $(this).parent();
			if(me == dropped)
				return;
			var subbranch = $(me).children("ul");
			if(subbranch.size() == 0) {
				me.find("span").addClass('plus on');
        me.find("label").after("<ul></ul>");
				subbranch = me.find("ul");
			}
			var oldParent = dropped.parent();
			subbranch.eq(0).append(dropped);
			var oldBranches = $("li", oldParent);
			if (oldBranches.size() == 0) {
      $(oldParent).parent().find('span').removeClass('plus');
      $(oldParent).remove(); }


      $(".drzewo input[type='checkbox']").each(function(){ sprawdz_checkbox($(this),0); } );

      przypisz();
		}
	});

    $(".drzewo div.separator").droppable({
		tolerance		: "pointer",
		hoverClass		: "hover",
		drop			: function(event, ui){
            var dropped = ui.draggable;
            dropped.css({top: 0, left: 0});

            var me = $(this).parents();
            if(me == dropped) return;

            var oldParent = dropped.parent();
            $(this).parent('li').before(dropped);
            //	alert($(this).parent('li').find('label').html());

            var oldBranches = $("li", oldParent);
            if (oldBranches.size() == 0) {
                $(oldParent).parent().find('span').removeClass('plus');
                $(oldParent).remove();
            }

            $(".drzewo input[type='checkbox']:checked").each(function(){ sprawdz_checkbox($(this),0); } );
            przypisz();
        }
	});


    $("li.tree_item").draggable({
        opacity: 0.4,
        revert: true,
        distance: 5
    });
}

    $('.tab').click(function(){
        view($('.tab.on'),'div_' + $('.tab.on').attr('id'));
        view($(this),'div_' + $(this).attr('id'));
        $('.drzewo').parents('div').toggleClass('on');
    });

    // zaznaczanie i odznaczanie drzewa
    function odznacz(ul){
        if(ul.find(".chbox:checked").size()==0){
            li_parent = ul.parents('li:first');
            li_parent.find(".chbox:first").attr('checked',false);
            $(li_parent.parents('ul:first')).each(function(){   odznacz($(this));   }); //rekurencja
        }
    }

    function sprawdz_checkbox(chbox,toggle){
        var li_parent = chbox.parents('li:first');
        var sub_chbox = li_parent.find(".chbox");

        if ( toggle ) {  //jesli z klikniecia
            if (!chbox.attr('checked')){
                chbox.attr('checked',false);
                sub_chbox.attr('checked',false); //odznaczam podrzdne
            }else{
                chbox.attr('checked',true);
                sub_chbox.attr('checked',true);  //zaznaczam podrzdne
            }
        }

        if (chbox.is(':checked')) chbox.parents('ul:first').parents('li').find(".chbox:first").attr('checked',true);  //zazmaczam nadrzdne
        else  chbox.parents('ul:first').each(function(){  odznacz($(this));   });  // rekyurencyjnie odznaczam nadrzdne jesli zadne z ic    h dzieci nie jest zaznaczone
    }


    //uzupelnia pola input type = hidden / parent_id, pozycja, wyswietl
    function przypisz(){
        $(".drzewo li").each( function(){
            var li = $(this);
            var label = $(this).find('label');

            var parent_id =  label.find('.parent_id');
            (p_id=li.parents('li:first').find('label .id').val())? parent_id.val(p_id) : parent_id.val(null);

            var pozycja =  label.find('.pozycja');
            pozycja.val( li.parent('ul').children('li').index(li));

            var wyswietl =  label.find('.wyswietl');
            (label.find('.chbox').is(':checked'))? wyswietl.val(1) : wyswietl.val(0);
            //alert('id:'+ li.find('.id:first').attr('value')+' parent:'+ parent_id.attr('value'));
            // alert(li.find('input[type="checkbox"]:checked:first'));
        });
    }


    $(".drzewo label").click(function(){
        sprawdz_checkbox($(this).find('input[type="checkbox"]'), 1);
        przypisz();
    });

    $("#save").click(function(){
        $.debug.print_r(parseTree($("#tag_tree")), "printOut", false);
    });

    if ( typeof($.fn.qsort) == 'function' ) {
        $('.drzewo').parents('div').find('ul').each( function(){
            $(this).children().qsort({
                attr: "pozycja",
                'digits' : true
            });
        });

        $('#sortuj').click(function(){
            $('div.on ul').each( function(){
                $(this).children().qsort({attr: "name", ignoreCase: true});
            });
            przypisz();
        });
    }
});