// Title: Tigra Tree
// Description: See the demo at url
// URL: http://www.softcomplex.com/products/tigra_menu_tree/
// Version: 1.1
// Date: 11-12-2002 (mm-dd-yyyy)
// Notes: This script is free. Visit official site for further details.
var trees_multi = [];

function tree_multi (a_items, a_template) {

    this.a_tpl      = a_template;
    this.a_config   = a_items;
    this.o_root     = this;
    this.a_index    = [];
    this.o_selected = null;
    this.n_depth    = -1;

    this.o_root.ajax = createXmlHttpRequestObject();

    //nowa zmienna typu boolean oznaczajaca czy dany element jest zaznaczony
    this.b_selected = null;
    this.n_children_selected = 0;

    var o_icone = new Image(),
        o_iconl = new Image();

    o_icone.src = a_template['icon_e'];
    o_iconl.src = a_template['icon_l'];
    a_template['im_e'] = o_icone;
    a_template['im_l'] = o_iconl;
    for (var i = 0; i < 64; i++)
        if (a_template['icon_' + i]) {
            var o_icon = new Image();
            a_template['im_' + i] = o_icon;
            o_icon.src = a_template['icon_' + i];
        }

    this.toggle = function (n_id) { var o_item = this.a_index[n_id]; o_item.open(o_item.b_opened) };
    this.select = function (n_id) { var o_item = this.a_index[n_id]; o_item.select(!o_item.b_selected, true); };
    this.mout   = function (n_id) { this.a_index[n_id].upstatus(true) };
    this.mover  = function (n_id) { this.a_index[n_id].upstatus() };


    this.a_children = [];
    for (var i = 0; i < a_items.length; i++)
        new tree_multi_item(this, i);

    this.b_children = this.a_children.length > 0;

    this.n_id = trees_multi.length;
    trees_multi[this.n_id] = this;

    this.html = '';
    for (var i = 0; i < this.a_children.length; i++) {
        this.a_children[i].open();
        this.a_children[i].b_opened = true;
        this.html += this.a_children[i].init();
    }
}



function tree_multi_item (o_parent, n_order) {

    this.n_depth  = o_parent.n_depth + 1;
    this.a_config = o_parent.a_config[n_order + (this.n_depth ? 4 : 0)];
    if (!this.a_config) return;

    this.o_root    = o_parent.o_root;
    this.o_parent  = o_parent;
    this.n_order   = n_order;
    this.b_opened  = !this.n_depth;

    this.b_selected = Boolean(this.a_config[2]);
    this.n_children_selected = 0; //nie uzywane

    this.n_id = this.o_root.a_index.length;
    this.o_root.a_index[this.n_id] = this;
    o_parent.a_children[n_order] = this;

    this.a_children = [];

    if( this.a_config.length - 4 > 0 ) {
        this.b_children = true;

        for (var i = 0; i < this.a_config.length - 4; i++)
            new tree_multi_item(this, i);

        this.b_children = this.a_children.length > 0;
    }

    this.get_icon = tree_multi_item_get_icon;
    this.open     = tree_multi_item_open;
    this.select   = tree_multi_item_select;
    this.init     = tree_multi_item_init;
    this.init_r   = tree_multi_item_init_r;
    this.upstatus = tree_multi_item_upstatus;

    this.is_last  = function () { return this.n_order == this.o_parent.a_children.length - 1 };
}

function tree_multi_item_open (b_close) {
    var o_idiv = document.getElementById('i_div' + this.o_root.n_id + '_' + this.n_id);

    if ( o_idiv ){
        if ( !o_idiv.innerHTML ) {
            var a_children = [];
            for (var i = 0; i < this.a_children.length; i++)
                a_children[i]= this.a_children[i].init();
            o_idiv.innerHTML = a_children.join('');
        }
        o_idiv.style.display = (b_close ? 'none' : 'block');

        this.b_opened = !b_close;
        var o_jicon = document.images['j_img' + this.o_root.n_id + '_' + this.n_id],
            o_iicon = document.images['i_img' + this.o_root.n_id + '_' + this.n_id];
        if (o_jicon) o_jicon.src = this.get_icon(true);
        if (o_iicon) o_iicon.src = this.get_icon();

        this.upstatus();
    }
}

function tree_multi_item_select( b_select, depth ) {
    this.b_selected = b_select;

    var o_chx = document.getElementById('multi_i_chx' + this.o_root.n_id + '_' + this.n_id);
    if ( o_chx ) {
        if ( o_chx.disabled ) {
            return;
        }
    }

    if ( b_select ){
        //depth
        if( depth ){
            //sprawdzam czy element posiada dzieci
            if( this.b_children){
                for(var i = 0; i < this.a_children.length; i++){
                    this.a_children[i].select(true, true);
                }
            }
        }

        var o_parent_item = this.o_parent;
        while( o_parent_item.n_depth >= 0 && !o_parent_item.b_selected ){
            o_parent_item.select(true, false);
            o_parent_item = o_parent_item.o_parent;
        }
    }else{
        if( depth ){
            for(var i=0; i < this.a_children.length; i++){
                this.a_children[i].select(false, true);
            }
        }
    }

/*
    var o_iicon = document.images['i_img' + this.o_root.n_id + '_' + this.n_id];
    if (o_iicon) o_iicon.src = this.get_icon();
*/
    try{
        document.getElementById('multi_i_txt' + this.o_root.n_id + '_' + this.n_id).style.fontWeight = b_select ? 'bold':'normal';
        if ( o_chx ) {
            o_chx.checked = b_select ? true:false;
        }
    }catch(e){
        //e.getMessage();
    }

    this.upstatus();

    return Boolean( this.a_config[1] );
}

function tree_multi_item_upstatus (b_clear) {
    //window.setTimeout('window.status="' + (b_clear ? '' : this.a_config[0] + (this.a_config[1] ? ' ('+ this.a_config[1] + ')' : '')) + '"', 10);
}

function tree_multi_item_init () {
    var a_offset = [],
        o_current_item = this.o_parent;

    for (var i = this.n_depth; i > 1; i--) {
        a_offset[i] = '<img src="' + this.o_root.a_tpl[o_current_item.is_last() ? 'icon_e' : 'icon_l'] + '" border="0" align="absbottom">';
        o_current_item = o_current_item.o_parent;
    }

    var html = new String();

    html = '<table cellpadding="0" cellspacing="0" border="0"><tr><td nowrap>' + (this.n_depth ? a_offset.join('') +
        (this.b_children ? '<span style="cursor:pointer" onclick="trees_multi[' + this.o_root.n_id + '].toggle(' + this.n_id + ')" onmouseover="trees_multi[' + this.o_root.n_id + '].mover(' + this.n_id + ')" onmouseout="trees_multi[' + this.o_root.n_id + '].mout(' + this.n_id + ')"><img src="' + this.get_icon(true) + '" border="0" align="absbottom" name="j_img' + this.o_root.n_id + '_' + this.n_id + '"></span>' : '<img src="' + this.get_icon(true) + '" border="0" align="absbottom">') : '')
        + '<input type="checkbox" name="' + this.o_root.a_tpl['checkbox_name'] + '[]" value="'+this.a_config[1]+'" class="chx ' + this.o_root.a_tpl['checkbox_name'] + '" ' + (this.b_selected?"checked=cheched disabled=disabled ":"") + ' id="multi_i_chx' + this.o_root.n_id + '_' + this.n_id + '" onclick="trees_multi[' + this.o_root.n_id + '].select(' + this.n_id + ');" align=absmiddle style="margin:0px;padding:0px;"> <label class="t' + this.o_root.n_id + 'i" for="multi_i_chx' + this.o_root.n_id + '_' + this.n_id + '" id="multi_i_txt' + this.o_root.n_id + '_' + this.n_id + '" style="font-weight: '+ (this.b_selected?"bold":"normal") + '; '+(this.b_selected?"color:#BFBFBF;": "")+' ">' + this.a_config[0] + '</label></td></tr></table>' ;


    if ( this.b_children ){
        html += '<div id="i_div' + this.o_root.n_id + '_' + this.n_id + '" '+( this.b_opened ? 'style="display:block"' : 'style="display:none"' )+' >';

        for(var k=0; k < this.a_children.length; k++)
            html += this.a_children[k].init();


        html += '</div>';
    }

    return html;
}

function tree_multi_item_init_r () {
    var a_offset = [],
        o_current_item = this.o_parent;

    for (var i = this.n_depth; i > 1; i--) {
        a_offset[i] = '<img src="' + this.o_root.a_tpl[o_current_item.is_last() ? 'icon_e' : 'icon_l'] + '" border="0" align="absbottom">';
        o_current_item = o_current_item.o_parent;
    }

    var html = new String();

    html = '<table cellpadding="0" cellspacing="0" border="0"><tr><td nowrap>' + (this.n_depth ? a_offset.join('') +
        (this.b_children ? '<span style="cursor:pointer" onclick="trees_multi[' + this.o_root.n_id + '].toggle(' + this.n_id + ')" onmouseover="trees_multi[' + this.o_root.n_id + '].mover(' + this.n_id + ')" onmouseout="trees_multi[' + this.o_root.n_id + '].mout(' + this.n_id + ')"><img src="' + this.get_icon(true) + '" border="0" align="absbottom" name="j_img' + this.o_root.n_id + '_' + this.n_id + '"></span>' : '<img src="' + this.get_icon(true) + '" border="0" align="absbottom">') : '')
        + '<input type="checkbox" name="' + this.o_root.a_tpl['checkbox_name'] + '[]" value="'+this.a_config[1]+'" ' + (this.b_selected?"checked":"") + ' id="multi_i_chx' + this.o_root.n_id + '_' + this.n_id + '" onclick="trees_multi[' + this.o_root.n_id + '].select(' + this.n_id + ');" align=absmiddle style="margin:0px;padding:0px;"> <label class="t' + this.o_root.n_id + 'i" for="multi_i_chx' + this.o_root.n_id + '_' + this.n_id + '" id="multi_i_txt' + this.o_root.n_id + '_' + this.n_id + '" style="font-weight: '+ (this.b_selected?"bold":"checked") + ';">' + this.a_config[0] + '</label></td></tr></table>' ;


    if( this.b_children ){
        html += '<div id="i_div' + this.o_root.n_id + '_' + this.n_id + '" style="display:none">';

        for(var k=0; k < this.a_children.length; k++)
            html += this.a_children[k].init();

        html += '</div>';
    }

    return html;
}


function tree_multi_item_get_icon (b_junction) {
    return this.o_root.a_tpl['icon_' + ((this.n_depth ? 0 : 32) + (this.b_children ? 16 : 0) + (this.b_children && this.b_opened ? 8 : 0) + (!b_junction && this.o_root.o_selected == this ? 4 : 0) + (b_junction ? 2 : 0) + (b_junction && this.is_last() ? 1 : 0))];
}


