
/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/



CREATE TABLE WWW_ZD (
    ID                       ID_D NOT NULL /* ID_D = INTEGER DEFAULT 0 NOT NULL */,
    USER_ID                  ID_D /* ID_D = INTEGER DEFAULT 0 NOT NULL */,
    DOSTAWCA_ID              ID_D /* ID_D = INTEGER DEFAULT 0 NOT NULL */,
    ADRES_IP                 ADRES_IP_D /* ADRES_IP_D = VARCHAR(15) DEFAULT '0.0.0.0' */,
    EMAIL                    ADRES_EMAIL_D /* ADRES_EMAIL_D = VARCHAR(64) */,
    TEL                      STRING20_D /* STRING20_D = VARCHAR(20) */,
    UWAGI_KLIENTA            BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ID_SPOSOBU_PLATNOSCI     SLOWNIK_D /* SLOWNIK_D = INTEGER */,
    NAZWA_SPOSOBU_PLATNOSCI  STRING100_D COLLATE PXW_PLK /* STRING100_D = VARCHAR(100) */,
    DATA_PLATNOSCI           DATA_D /* DATA_D = DATE */,
    DOSTAWA_ID_ADRESU        SLOWNIK_D /* SLOWNIK_D = INTEGER */,
    DOSTAWA_ULICA            STRING40_D COLLATE PXW_PLK /* STRING40_D = VARCHAR(40) */,
    DOSTAWA_NR_DOMU          STRING10_D COLLATE PXW_PLK /* STRING10_D = VARCHAR(10) */,
    DOSTAWA_NR_LOKALU        STRING10_D COLLATE PXW_PLK /* STRING10_D = VARCHAR(10) */,
    DOSTAWA_KOD_POCZTOWY     STRING10_D COLLATE PXW_PLK /* STRING10_D = VARCHAR(10) */,
    DOSTAWA_MIEJSCOWOSC      STRING40_D COLLATE PXW_PLK /* STRING40_D = VARCHAR(40) */,
    DOSTAWA_PANSTWO          STRING40_D COLLATE PXW_PLK /* STRING40_D = VARCHAR(40) */
);




/******************************************************************************/
/****                             Foreign Keys                             ****/
/******************************************************************************/

ALTER TABLE WWW_ZD ADD CONSTRAINT WWW_ZD_ADRES_DOSTAWY_ID_FK FOREIGN KEY (DOSTAWA_ID_ADRESU) REFERENCES R3_CONTACT_ADDRESSES (ID) ON DELETE SET NULL ON UPDATE CASCADE;
ALTER TABLE WWW_ZD ADD CONSTRAINT WWW_ZD_DOSTAWCA_ID_FK FOREIGN KEY (DOSTAWCA_ID) REFERENCES R3_CONTACTS (ID) ON DELETE SET NULL ON UPDATE CASCADE;
ALTER TABLE WWW_ZD ADD CONSTRAINT WWW_ZD_ID_FK FOREIGN KEY (ID) REFERENCES GM_ZD (ID) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE WWW_ZD ADD CONSTRAINT WWW_ZD_ID_SPOSOBU_PLATNOSCI_FK FOREIGN KEY (ID_SPOSOBU_PLATNOSCI) REFERENCES GM_SPOSOBY_ZAP (ID) ON DELETE SET NULL ON UPDATE CASCADE;
ALTER TABLE WWW_ZD ADD CONSTRAINT WWW_ZD_USER_ID_FK FOREIGN KEY (USER_ID) REFERENCES WWW_USERS (ID) ON DELETE SET NULL ON UPDATE CASCADE;


/******************************************************************************/
/****                               Indices                                ****/
/******************************************************************************/

CREATE INDEX WWW_ZD_ADRES_IP_IND ON WWW_ZD (ADRES_IP);
CREATE INDEX WWW_ZD_EMAIL_IND ON WWW_ZD (EMAIL);


/* Fields descriptions */

DESCRIBE FIELD ID TABLE WWW_ZD
'Wzr typu dla pl zawierajcych identyfikator rekordu (musi zawiera warto)';

DESCRIBE FIELD USER_ID TABLE WWW_ZD
'Wzr typu dla pl zawierajcych identyfikator rekordu (musi zawiera warto)';

DESCRIBE FIELD DOSTAWCA_ID TABLE WWW_ZD
'Wzr typu dla pl zawierajcych identyfikator rekordu (musi zawiera warto)';



/******************************************************************************/
/****                              Privileges                              ****/
/******************************************************************************/


/* Privileges of roles */
GRANT ALL ON WWW_ZD TO WWW_ROLE;
