
/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/


CREATE GENERATOR WWW_IMAGES_GEN_ID;

CREATE TABLE WWW_IMAGES (
    ID          INTEGER NOT NULL,
    MODEL       STRING50_D NOT NULL /* STRING50_D = VARCHAR(50) */,
    MODEL_ID    INTEGER NOT NULL,
    IMG_NAME    NAZWA_D /* NAZWA_D = VARCHAR(250) NOT NULL */,
    IMG_EXT     STRING10_D COLLATE PXW_PLK /* STRING10_D = VARCHAR(10) */,
    IMG_SIZE    INTEGER,
    IMG_TYPE    STRING25_D /* STRING25_D = VARCHAR(25) */,
    IMG_WIDTH   INTEGER,
    IMG_HEIGHT  INTEGER,
    GUID        GUID_D /* GUID_D = CHAR(36) */
);




/******************************************************************************/
/****                             Primary Keys                             ****/
/******************************************************************************/

ALTER TABLE WWW_IMAGES ADD CONSTRAINT PK_WWW_IMAGES PRIMARY KEY (ID);


/******************************************************************************/
/****                               Indices                                ****/
/******************************************************************************/

CREATE INDEX WWW_IMAGES_GUID_IND ON WWW_IMAGES (GUID);
CREATE INDEX WWW_IMAGES_MODEL_IND ON WWW_IMAGES (MODEL, MODEL_ID);
CREATE INDEX WWW_IMAGES_NAME_IND ON WWW_IMAGES (IMG_NAME);


/******************************************************************************/
/****                               Triggers                               ****/
/******************************************************************************/


SET TERM ^ ;


/******************************************************************************/
/****                         Triggers for tables                          ****/
/******************************************************************************/



/* Trigger: WWW_IMAGES_BI */
CREATE TRIGGER WWW_IMAGES_BI FOR WWW_IMAGES
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN
    NEW.ID = GEN_ID(WWW_IMAGES_GEN_ID,1);
END
^


SET TERM ; ^

/**************************************************************************************************/

alter table WWW_PARAM_WART
add constraint WWW_PARAM_WART_IMAGE_ID_FK
foreign key (IMAGE_ID)
references WWW_IMAGES(ID)
on delete SET NULL
on update CASCADE;

GRANT ALL ON WWW_IMAGES TO WWW_ROLE;

