<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */

require_once('Cache/Lite.php');

function smarty_function_kategorie_lista($params, &$smarty){
    global $dbh1;

    $ext  = $smarty->get_template_vars('ext');
    $gid  = $smarty->get_template_vars('gid');
    $tree = $smarty->get_template_vars('drzewko');

    if ( defined('GM_GRUPAT_EXT_ID') && GM_GRUPAT_EXT_ID > 0 ) {
        $ext = true;
    }

    if ( empty($tree) ) {
        if( !class_exists('drzewko') ){
            require_once( INCLUDE_DIR . '/drzewko.class.php' );
        }

        //$tree = new drzewko('towary', $gid, false );
        $tree = make_tree( $gid, $ext );
    }


    $grupy = array();

    $Cache_Lite = new Cache_Lite(array(
        'cacheDir' => TEMP_DIR . '/cache/',
        'lifeTime' => 600, //10 min
    ));

    $cache_id = 'tree-www-grupy' . intval($ext) . '-' . INSTALACJA;
    $cache_group = 'smarty';

    if (  true || !$data = $Cache_Lite->get($cache_id, $cache_group, !is_resource($dbh1)) ) {
        if ( is_resource($dbh1) ) {
            $res = ibase_query($dbh1, 'SELECT b.* FROM gm_grupyt'.($ext ? '_ext' : '').' a left join WWW_GRUPYT'.($ext ? '_ext' : '').' b on ( a.ID = b.ID AND '.instalacja_where().' ) ' );
            if ( $res ) {
                while ( $grupa = ibase_fetch_assoc($res) ) {
                    $grupa = array_change_key_case($grupa, CASE_LOWER);
                    $grupy[$grupa['id']] = $grupa;
                }
                ibase_free_result( $res );
                $Cache_Lite->save( serialize($grupy), $cache_id, $cache_group );
            }
        }
    } else {
        $grupy = unserialize($data);
    }

//    if( empty($grupy) ){
//        return;
//    }

    //wyswietla liste grup
    //pre($grupy);
    $kategorie = array();
    tree_kategorie_lista( $tree->items[0]->items, $kategorie, $grupy, $ext, 'first' );

    $smarty->assign('kategorie', $kategorie );
}
/**
 * funkcja ktra tworzy luiste kategorii na pdostawie drzewka
 * 
 * @param array $cats
 * @param array $kategorie
 * @param array $ext
 * @param bool $ext
 * @param string $level (first|last|all) wybiera odpowiednie kategorie:
 *                      first tylko z pierwszego poziomu
 *                      last tylko kategorie ktre nie maja podkategorii
 *                      all wszystkie
 */
function tree_kategorie_lista( &$cats, &$kategorie = array(), &$grupy = array(), $ext = false, $level = 'first' ){


    foreach( $cats as $cat ){
        $kategoria = array(
            'id' => $cat->id,
            'url' => URL_PATH . '/' . name2url($cat->nazwa).'-g' . intval($ext). '-' . $cat->id . '.html',
            'nazwa' => $cat->nazwa,
            'opis' => '',
            'ico_url' => '',
            'photo_url' => '',
            'img_url' => '',
        );


        if ( isset($grupy[$cat->id]) ) {
            if ( !empty($grupy[$cat->id]['photo_file'])){
                $kategoria['photo_url'] = IMAGES_URL . '/' .$grupy[$cat->id]['photo_file'];
            }

            if ( !empty($grupy[$cat->id]['img'])  ){
                $kategoria['ico_url'] = IMAGES_URL . '/' .$grupy[$cat->id]['img'];
            }

            if( !empty($kategoria['photo_url']) ){
                $kategoria['img_url'] = $kategoria['photo_url'];
            }else if( !empty($kategoria['ico_url']) ){
                $kategoria['img_url'] = $kategoria['ico_url'];
            }

            if ( !empty($grupy[$cat->id]['opis']) ){
                $kategoria['opis'] = $grupy[$cat->id]['opis'];
            }
        }

        if ( $level == 'first' ) {
            $kategorie[] = $kategoria;
        } else if ( $level == 'all' ) {
            $kategorie[] = $kategoria;

            if ( !empty( $cat->items) ) {
                tree_kategorie_lista( $cat->items, $kategorie, $grupy, $ext, $level );
            }
        } else if( $level == 'last' ){
            if ( empty( $cat->items) ) {
                $kategorie[] = $kategoria;
            }else{
                tree_kategorie_lista( $cat->items, $kategorie, $grupy, $ext, $level );
            }
        }
    }
}





